﻿Shader "Mgin/ShaderTest" {
	Properties
	{
		_MainTex ("",2D) = "white" {}
		_Cutoff ("", Float) = 0.5
		_Color ("", Color ) = (1,1,1,1)
	}
	Category
	{
		Fog { Mode Off }
		SubShader
		{
			Tags { "RenderType" = "Opaque" "DepthRender"="Opaque" }
			Pass{
CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#include "UnityCG.cginc"

struct v2f {
	float4 pos : SV_POSITION;
	float depth : TEXCOORD0;
};
v2f vert (appdata_base v) {
	v2f o;
	o.pos = mul (UNITY_MATRIX_MVP, v.vertex);		
	
	// x is 1.0 (or –1.0 if currently rendering with a flipped projection matrix), 
	// y is the camera’s near plane, z is the camera’s far plane and w is 1/FarPlane.				
	//o.depth = mul(UNITY_MATRIX_MVP, v.vertex).z * _ProjectionParams.w;						
	//o.depth = mul(UNITY_MATRIX_IT_MV, v.vertex).z;		
	
	// 1. 뷰 공간에서 시점이 원점, 원점에서 정점의 거리가 곧 깊이값이 된다.
	//o.depth = length(mul(UNITY_MATRIX_MV, v.vertex))* _ProjectionParams.w;

	// 2. 
	///o.depth = o.pos.w * _ProjectionParams.w;						

	o.depth = mul(UNITY_MATRIX_IT_MV, v.vertex).z* _ProjectionParams.w;

	return o;
}
half4 frag(v2f i) : SV_Target 
{						
	return fixed4(i.depth, i.depth, i.depth, 1);	
}

/*
sampler2D _CameraDepthTexture;

struct v2f {
   float4 pos : SV_POSITION;
   float4 scrPos:TEXCOORD1;
};

//Vertex Shader
v2f vert (appdata_base v){
   v2f o;
   o.pos = mul (UNITY_MATRIX_MVP, v.vertex);
   o.scrPos=ComputeScreenPos(o.pos);   

   return o;
}

//Fragment Shader
half4 frag (v2f i) : COLOR{
   float depthValue = Linear01Depth (tex2Dproj(_CameraDepthTexture, UNITY_PROJ_COORD(i.scrPos)).r);
   half4 depth;

   depth.r = depthValue;
   depth.g = depthValue;
   depth.b = depthValue;

   depth.a = 1;
   return depth;
}
*/

					//http://williamchyr.com/2013/11/unity-shaders-depth-and-normal-textures/
					//http://www.gpgstudy.com/forum/viewtopic.php?t=1337&highlight=
					//http://docs.unity3d.com/kr/current/Manual/SL-CameraDepthTexture.html
					//http://raptusgames.com/youre-such-a-nerd-b-vol03/
					//http://answers.unity3d.com/questions/877170/render-scene-depth-to-a-texture.html
				ENDCG
			}
		}
	}
}
// https://en.wikibooks.org/wiki/Cg_Programming/Unity/Shading_in_World_Space
// https://github.com/robertcupisz/LightShafts/blob/master/Depth.shader
// http://forum.unity3d.com/threads/_projectionparams-z-is-not-equal-to-camera-farclipplane.204592/